Backport of:

From 4326d6b9041a3bcb9b529f9163d0761c2d760700 Mon Sep 17 00:00:00 2001
From: Yann Ylavic <ylavic@apache.org>
Date: Wed, 26 Jun 2024 14:56:47 +0000
Subject: [PATCH] factor out IS_SLASH, perdir fix

in per-dir, the filename will be internally redirected, so / is OK too.


don't add / to / in the non-perdir


match AP_IS_SLASH macro

followup to 1918651


Merges r1918651, r1918652, r1918663 from trunk
Reviewed by: covener, ylavic, rpluem
GH: close #458


git-svn-id: https://svn.apache.org/repos/asf/httpd/httpd/branches/2.4.x@1918668 13f79535-47bb-0310-9956-ffa450edef68
---
 include/ap_mmn.h              |  3 ++-
 include/httpd.h               | 11 +++++++++++
 modules/mappers/mod_rewrite.c | 11 ++++-------
 server/util.c                 | 31 ++++++++++---------------------
 4 files changed, 27 insertions(+), 29 deletions(-)

Index: apache2-2.4.29/include/httpd.h
===================================================================
--- apache2-2.4.29.orig/include/httpd.h	2026-05-20 18:25:19.889922258 +0100
+++ apache2-2.4.29/include/httpd.h	2026-05-20 18:25:19.868922213 +0100
@@ -2460,6 +2460,17 @@
  */
 AP_DECLARE(int) ap_cstr_casecmpn(const char *s1, const char *s2, apr_size_t n);
 
+/* Win32/NetWare/OS2 need to check for both forward and back slashes
+ * in ap_normalize_path() and ap_escape_url().
+ */
+#ifdef CASE_BLIND_FILESYSTEM
+#define AP_IS_SLASH(s) ((s == '/') || (s == '\\'))
+#define AP_SLASHES "/\\"
+#else
+#define AP_IS_SLASH(s) (s == '/')
+#define AP_SLASHES "/"
+#endif
+
 #ifdef __cplusplus
 }
 #endif
Index: apache2-2.4.29/modules/mappers/mod_rewrite.c
===================================================================
--- apache2-2.4.29.orig/modules/mappers/mod_rewrite.c	2026-05-20 18:25:19.889922258 +0100
+++ apache2-2.4.29/modules/mappers/mod_rewrite.c	2026-05-20 18:25:19.871922219 +0100
@@ -644,14 +644,11 @@
 
 static int is_absolute_path(const char *path)
 {
-#ifndef WIN32
+#ifndef CASE_BLIND_FILESYSTEM
     return (path[0] == '/');
 #else
-#define IS_SLASH(c) ((c) == '/' || (c) == '\\')
-    /* "//", "\\", "x:/" and "x:\" are absolute paths on Windows */
-    return ((IS_SLASH(path[0]) && path[1] == path[0])
-            || (apr_isalpha(path[0]) && path[1] == ':' && IS_SLASH(path[2])));
-#undef IS_SLASH
+    return ((AP_IS_SLASH(path[0]) && path[1] == path[0])
+            || (apr_isalpha(path[0]) && path[1] == ':' && AP_IS_SLASH(path[2])));
 #endif
 }
 
@@ -4365,11 +4362,11 @@
      */
     if (!is_proxyreq
         && !is_absolute_path(newuri)
+        && !AP_IS_SLASH(*newuri)
         && !is_absolute_uri(newuri, NULL)) {
         if (ctx->perdir) {
             rewritelog((r, 3, ctx->perdir, "add per-dir prefix: %s -> %s%s",
                        newuri, ctx->perdir, newuri));
-
             newuri = apr_pstrcat(r->pool, ctx->perdir, newuri, NULL);
         }
         else if (!(p->flags & (RULEFLAG_PROXY | RULEFLAG_FORCEREDIRECT))) {
Index: apache2-2.4.29/server/util.c
===================================================================
--- apache2-2.4.29.orig/server/util.c	2026-05-20 18:25:19.889922258 +0100
+++ apache2-2.4.29/server/util.c	2026-05-20 18:25:19.878922234 +0100
@@ -81,17 +81,6 @@
  */
 #define TEST_CHAR(c, f)        (test_char_table[(unsigned char)(c)] & (f))
 
-/* Win32/NetWare/OS2 need to check for both forward and back slashes
- * in ap_getparents() and ap_escape_url.
- */
-#ifdef CASE_BLIND_FILESYSTEM
-#define IS_SLASH(s) ((s == '/') || (s == '\\'))
-#define SLASHES "/\\"
-#else
-#define IS_SLASH(s) (s == '/')
-#define SLASHES "/"
-#endif
-
 /* we know core's module_index is 0 */
 #undef APLOG_MODULE_INDEX
 #define APLOG_MODULE_INDEX AP_CORE_MODULE_INDEX
@@ -507,8 +496,8 @@
 
     l = w = first_dot = next - name;
     while (name[l] != '\0') {
-        if (name[l] == '.' && IS_SLASH(name[l + 1])
-            && (l == 0 || IS_SLASH(name[l - 1])))
+        if (name[l] == '.' && AP_IS_SLASH(name[l + 1])
+            && (l == 0 || AP_IS_SLASH(name[l - 1])))
             l += 2;
         else
             name[w++] = name[l++];
@@ -517,7 +506,7 @@
     /* b) remove trailing . path, segment */
     if (w == 1 && name[0] == '.')
         w--;
-    else if (w > 1 && name[w - 1] == '.' && IS_SLASH(name[w - 2]))
+    else if (w > 1 && name[w - 1] == '.' && AP_IS_SLASH(name[w - 2]))
         w--;
     name[w] = '\0';
 
@@ -525,13 +514,13 @@
     l = first_dot;
 
     while (name[l] != '\0') {
-        if (name[l] == '.' && name[l + 1] == '.' && IS_SLASH(name[l + 2])
-            && (l == 0 || IS_SLASH(name[l - 1]))) {
+        if (name[l] == '.' && name[l + 1] == '.' && AP_IS_SLASH(name[l + 2])
+            && (l == 0 || AP_IS_SLASH(name[l - 1]))) {
             int m = l + 3, n;
 
             l = l - 2;
             if (l >= 0) {
-                while (l >= 0 && !IS_SLASH(name[l]))
+                while (l >= 0 && !AP_IS_SLASH(name[l]))
                     l--;
                 l++;
             }
@@ -549,10 +538,10 @@
     if (l == 2 && name[0] == '.' && name[1] == '.')
         name[0] = '\0';
     else if (l > 2 && name[l - 1] == '.' && name[l - 2] == '.'
-             && IS_SLASH(name[l - 3])) {
+             && AP_IS_SLASH(name[l - 3])) {
         l = l - 4;
         if (l >= 0) {
-            while (l >= 0 && !IS_SLASH(name[l]))
+            while (l >= 0 && !AP_IS_SLASH(name[l]))
                 l--;
             l++;
         }
@@ -1851,7 +1840,7 @@
 AP_DECLARE(int) ap_unescape_url(char *url)
 {
     /* Traditional */
-    return unescape_url(url, SLASHES, NULL);
+    return unescape_url(url, AP_SLASHES, NULL);
 }
 AP_DECLARE(int) ap_unescape_url_keep2f(char *url, int decode_slashes)
 {
@@ -1861,7 +1850,7 @@
         return unescape_url(url, NULL, NULL);
     } else {
         /* reserve (do not decode) encoded slashes */
-        return unescape_url(url, NULL, SLASHES);
+        return unescape_url(url, NULL, AP_SLASHES);
     }
 }
 #ifdef NEW_APIS
